=== debian/changelog ===
btas (0.0+git20221014.147bf4d4-1) unstable; urgency=medium

  * Initial upload.

 -- Michael Banck <mbanck@debian.org>  Sat, 03 Dec 2022 18:09:31 +0100
