=== debian/control ===
Source: btas
Section: libdevel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake,
               debhelper (>= 11),
               libboost-container-dev,
               libboost-dev,
               libboost-serialization-dev
Standards-Version: 4.5.1
Homepage: https://github.com/ValeevGroup/btas
Vcs-Browser: https://salsa.debian.org/debichem-team/btas
Vcs-Git: https://salsa.debian.org/debichem-team/btas.git

Package: libbtas-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Basic Tensor Algebra Subroutines Library (development files)
 BTAS (Basic Tensor Algebra Subroutines) is a library for tensor algebra.
 It is a reference implementation of the Tensor Working Group concept spec.
 .
 This package contains the static libraries and the header files.
