=== debian/watch ===
version=3
https://github.com/ValeevGroup/btas/releases .*/archive/refs/tags/v([\d.]+)\.tar\.(?:bz2|gz)
