## btas 1.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,9 @@
 #; -*-CMake-*-
 
 cmake_minimum_required (VERSION 3.14.0)  # FetchContent_MakeAvailable
+
+# Preload versions/tags of all dependencies ====================================
+include(external/versions.cmake)
 
 ###############################################################################
 # CMake defaults to address key pain points
@@ -24,6 +27,7 @@
         vg_cmake_kit
         QUIET
         GIT_REPOSITORY      https://github.com/ValeevGroup/kit-cmake.git
+        GIT_TAG             ${BTAS_TRACKED_VGCMAKEKIT_TAG}
         SOURCE_DIR ${${VG_CMAKE_KIT_PREFIX_DIR}}/cmake/vg
         BINARY_DIR ${${VG_CMAKE_KIT_PREFIX_DIR}}/cmake/vg-build
         SUBBUILD_DIR ${${VG_CMAKE_KIT_PREFIX_DIR}}/cmake/vg-subbuild
@@ -38,7 +42,7 @@
 set(BTAS_MAJOR_VERSION 1)
 set(BTAS_MINOR_VERSION 0)
 set(BTAS_MICRO_VERSION 0)
-set(BTAS_PRERELEASE_ID alpha.1)
+set(BTAS_PRERELEASE_ID )
 set(BTAS_VERSION "${BTAS_MAJOR_VERSION}.${BTAS_MINOR_VERSION}.${BTAS_MICRO_VERSION}")
 if (BTAS_PRERELEASE_ID)
   set(BTAS_EXT_VERSION "${BTAS_VERSION}-${BTAS_PRERELEASE_ID}")
@@ -60,6 +64,7 @@
 include(RedefaultableOption)
 include(CMakePackageConfigHelpers)
 include(AddCustomTargetSubproject)
+include(CMakePushCheckState)
 include(CTest) # defines BUILD_TESTING option
 
 # Configure options
@@ -77,28 +82,27 @@
 
 set(TARGET_ARCH "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}")
 
-include(CMakePushCheckState)
+##########################
+# INSTALL variables
+##########################
 include(GNUInstallDirs)
+set(BTAS_INSTALL_BINDIR "${CMAKE_INSTALL_BINDIR}"
+    CACHE PATH "BTAS BIN install directory")
+set(BTAS_INSTALL_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}"
+    CACHE PATH "BTAS INCLUDE install directory")
+set(BTAS_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}"
+    CACHE PATH "BTAS LIB install directory")
+set(BTAS_INSTALL_DATADIR "${CMAKE_INSTALL_DATAROOTDIR}/BTAS/${BTAS_EXT_VERSION}"
+    CACHE PATH "BTAS DATA install directory")
+set(BTAS_INSTALL_DOCDIR "${BTAS_INSTALL_DATADIR}/doc"
+    CACHE PATH "BTAS DOC install directory")
+set(BTAS_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/BTAS"
+    CACHE PATH "BTAS CMAKE install directory")
+
+##########################
+# Standard build variables
+##########################
 include(AppendFlags)
-
-##########################
-# Standard build variables
-##########################
-set(BTAS_INSTALL_BINDIR "bin"
-    CACHE PATH "BTAS BIN install directory")
-set(BTAS_INSTALL_INCLUDEDIR "include"
-    CACHE PATH "BTAS INCLUDE install directory")
-set(BTAS_INSTALL_LIBDIR "lib"
-    CACHE PATH "BTAS LIB install directory")
-set(BTAS_INSTALL_SHAREDIR "share/BTAS/${BTAS_MAJOR_VERSION}.${BTAS_MINOR_VERSION}.${BTAS_MICRO_VERSION}"
-    CACHE PATH "BTAS SHARE install directory")
-set(BTAS_INSTALL_DATADIR "${BTAS_INSTALL_SHAREDIR}/data"
-    CACHE PATH "BTAS DATA install directory")
-set(BTAS_INSTALL_DOCDIR "${BTAS_INSTALL_SHAREDIR}/doc"
-    CACHE PATH "BTAS DOC install directory")
-set(BTAS_INSTALL_CMAKEDIR "lib/cmake/BTAS"
-    CACHE PATH "BTAS CMAKE install directory")
-
 # Get standard build variables from the environment if they have not already been set
 if(NOT CMAKE_C_FLAGS OR NOT DEFINED CMAKE_C_FLAGS)
   set(CMAKE_C_FLAGS "$ENV{CPPFLAGS}")
@@ -155,6 +159,15 @@
 ##########################
 # external dependencies
 ##########################
+# optional dependency: ccache, but need to be defined first so that mandatory dependencies can inherit it
+find_program(CCACHE ccache)
+if(CCACHE)
+  mark_as_advanced(CCACHE)
+  message (STATUS "Found ccache: ${CCACHE}")
+  set(CMAKE_CXX_COMPILER_LAUNCHER "${CCACHE}" CACHE STRING "Compiler launcher to use for compiling C++")
+  set(CMAKE_C_COMPILER_LAUNCHER "${CCACHE}" CACHE STRING "Compiler launcher to use for compiling C")
+endif(CCACHE)
+
 if( BTAS_USE_BLAS_LAPACK )
   include(external/linalgpp.cmake)
 endif()
@@ -176,7 +189,7 @@
 # checking/testing
 ##########################
 if (BUILD_TESTING)
-  add_custom_target_subproject(btas check USES_TERMINAL COMMAND ${CMAKE_CTEST_COMMAND} -V)
+  add_custom_target_subproject(btas check USES_TERMINAL COMMAND ${CMAKE_CTEST_COMMAND} -V -R "btas/unit/run")
   add_subdirectory(unittest)
 else(BUILD_TESTING)
   add_custom_target_subproject(btas check COMMAND echo "WARNING: unit testing disabled. To enable, give -DBUILD_TESTING=ON to cmake")
@@ -221,8 +234,11 @@
     COMMAND ${CMAKE_COMMAND} -DCOMPONENT=btas-config -P ${PROJECT_BINARY_DIR}/cmake_install.cmake
     COMMENT "Installing BTAS config components")
 
-feature_summary(WHAT ALL
-    DESCRIPTION "=== BTAS Package/Feature Info ===")
+if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
+  feature_summary(WHAT ALL
+          DESCRIPTION "=== BTAS Package/Feature Info ===")
+  feature_summary(FILENAME ${CMAKE_CURRENT_BINARY_DIR}/features.log WHAT ALL)
+endif()
 
 ###############################################################################
 # appendix: misc details
