=== debian/changelog ===
btas (1.0.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add Depends on libbtas-dev to fulfill CMake declared dependencies.
    (Closes: #1028634)

 -- Bastian Germann <bage@debian.org>  Tue, 09 Sep 2025 12:36:51 +0200

btas (1.0.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch: Updated.
  * debian/patches/fix_build_error.patch: Removed, included upstream. 
  * debian/control (Build-Depends): Added libboost-random-dev. 
  * debian/rules (override_dh_auto_configure, override_dh_auto_build): Removed,
    no longer needed.
  * debian/control (Build-Depends): Added libblas-dev, libblaspp-dev,
    liblapack-dev and liblapackpp-dev.
  * debian/patches/cmake_modules.patch: New patch, adds required cmake modules
    from kit-cmake/linalg-cmake-modules repositories.
  * debian/patches/vendored_cmake_modules.patch: New patch, adjusts the cmake
    search path to the local cmake/modules directory.
  * debian/patches/fix_ctest.patch: New patch, fixes the unittests so that they
    find the required data files.

 -- Michael Banck <mbanck@debian.org>  Sun, 30 Mar 2025 13:11:02 +0200
