=== debian/control ===
--- 
+++ 
@@ -7,7 +7,12 @@
                debhelper (>= 11),
                libboost-container-dev,
                libboost-dev,
-               libboost-serialization-dev
+               libboost-random-dev,
+               libboost-serialization-dev,
+               libblas-dev,
+               libblaspp-dev,
+               liblapack-dev,
+               liblapackpp-dev
 Standards-Version: 4.5.1
 Homepage: https://github.com/ValeevGroup/btas
 Vcs-Browser: https://salsa.debian.org/debichem-team/btas
@@ -15,7 +20,13 @@
 
 Package: libbtas-dev
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+         libboost-random-dev,
+         libboost-serialization-dev,
+         libblaspp-dev,
+         liblapack-dev,
+         liblapackpp-dev
 Description: Basic Tensor Algebra Subroutines Library (development files)
  BTAS (Basic Tensor Algebra Subroutines) is a library for tensor algebra.
  It is a reference implementation of the Tensor Working Group concept spec.
