=== debian/rules ===
--- 
+++ 
@@ -20,15 +20,3 @@
 
 %:
 	dh $@  --buildsystem=cmake
-
-override_dh_auto_configure:
-	dh_auto_configure -- 					\
-		-DCMAKE_BUILD_TYPE=${BUILD_TYPE}		\
-		-DBTAS_BUILD_UNITTEST=ON			\
-		-DBTAS_ASSERT_THROWS=ON				\
-		-DBTAS_USE_CBLAS_LAPACKE=OFF			\
-		-DBTAS_USE_BLAS_LAPACK=OFF
-
-override_dh_auto_build:
-	dh_auto_build
-	(cd obj-*/unittest && make btas_test)
