=== debian/watch ===
version=3
https://github.com/ValeevGroup/btas/tags .*/v([\d.]+)\.tar\.(?:bz2|gz)
